diff --git a/web/pgadmin/utils/driver/psycopg2/typecast.py b/web/pgadmin/utils/driver/psycopg2/typecast.py
new file mode 100644
index 000000000..2a15fb443
--- /dev/null
+++ b/web/pgadmin/utils/driver/psycopg2/typecast.py
@@ -0,0 +1,265 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2022, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+"""
+Typecast various data types so that they can be compatible with Javascript
+data types.
+"""
+
+from psycopg2 import STRING as _STRING
+from psycopg2.extensions import FLOAT as _FLOAT
+from psycopg2.extensions import DECIMAL as _DECIMAL, encodings
+import psycopg2
+from psycopg2.extras import Json as psycopg2_json
+
+from .encoding import configure_driver_encodings, get_encoding
+
+configure_driver_encodings(encodings)
+
+# OIDs of data types which need to typecast as string to avoid JavaScript
+# compatibility issues.
+# e.g JavaScript does not support 64 bit integers. It has 64-bit double
+# giving only 53 bits of integer range (IEEE 754)
+# So to avoid loss of remaining 11 bits (64-53) we need to typecast bigint to
+# string.
+
+TO_STRING_DATATYPES = (
+    # To cast bytea, interval type
+    17, 1186,
+
+    # date, timestamp, timestamp with zone, time without time zone
+    1082, 1114, 1184, 1083
+)
+
+TO_STRING_NUMERIC_DATATYPES = (
+    # Real, double precision, numeric, bigint
+    700, 701, 1700, 20
+)
+
+# OIDs of array data types which need to typecast to array of string.
+# This list may contain:
+# OIDs of data types from PSYCOPG_SUPPORTED_ARRAY_DATATYPES as they need to be
+# typecast to array of string.
+# Also OIDs of data types which psycopg2 does not typecast array of that
+# data type. e.g: uuid, bit, varbit, etc.
+
+TO_ARRAY_OF_STRING_DATATYPES = (
+    # To cast bytea[] type
+    1001,
+
+    # bigint[]
+    1016,
+
+    # double precision[], real[]
+    1022, 1021,
+
+    # bit[], varbit[]
+    1561, 1563,
+)
+
+# OID of record array data type
+RECORD_ARRAY = (2287,)
+
+# OIDs of builtin array datatypes supported by psycopg2
+# OID reference psycopg2/psycopg/typecast_builtins.c
+#
+# For these array data types psycopg2 returns result in list.
+# For all other array data types psycopg2 returns result as string (string
+# representing array literal)
+# e.g:
+#
+# For below two sql psycopg2 returns result in different formats.
+#   SELECT '{foo,bar}'::text[];
+#   print('type of {} ==> {}'.format(res[0], type(res[0])))
+#   SELECT '{<a>foo</a>,<b>bar</b>}'::xml[];
+#   print('type of {} ==> {}'.format(res[0], type(res[0])))
+#
+# Output:
+#   type of ['foo', 'bar'] ==> <type 'list'>
+#   type of {<a>foo</a>,<b>bar</b>} ==> <type 'str'>
+
+PSYCOPG_SUPPORTED_BUILTIN_ARRAY_DATATYPES = (
+    1016, 1005, 1006, 1007, 1021, 1022, 1231,
+    1002, 1003, 1009, 1014, 1015, 1009, 1014,
+    1015, 1000, 1115, 1185, 1183, 1270, 1182,
+    1187, 1001, 1028, 1013, 1041, 651, 1040
+)
+
+# json, jsonb
+# OID reference psycopg2/lib/_json.py
+PSYCOPG_SUPPORTED_JSON_TYPES = (114, 3802)
+
+# json[], jsonb[]
+PSYCOPG_SUPPORTED_JSON_ARRAY_TYPES = (199, 3807)
+
+ALL_JSON_TYPES = PSYCOPG_SUPPORTED_JSON_TYPES +\
+    PSYCOPG_SUPPORTED_JSON_ARRAY_TYPES
+
+# INET[], CIDR[]
+# OID reference psycopg2/lib/_ipaddress.py
+PSYCOPG_SUPPORTED_IPADDRESS_ARRAY_TYPES = (1041, 651)
+
+# uuid[]
+# OID reference psycopg2/lib/extras.py
+PSYCOPG_SUPPORTED_IPADDRESS_ARRAY_TYPES = (2951,)
+
+# int4range, int8range, numrange, daterange tsrange, tstzrange[]
+# OID reference psycopg2/lib/_range.py
+PSYCOPG_SUPPORTED_RANGE_TYPES = (3904, 3926, 3906, 3912, 3908, 3910)
+
+# int4range[], int8range[], numrange[], daterange[] tsrange[], tstzrange[]
+# OID reference psycopg2/lib/_range.py
+PSYCOPG_SUPPORTED_RANGE_ARRAY_TYPES = (3905, 3927, 3907, 3913, 3909, 3911)
+
+
+def register_global_typecasters():
+    unicode_type_for_record = psycopg2.extensions.new_type(
+        (2249,),
+        "RECORD",
+        psycopg2.extensions.UNICODE
+    )
+
+    unicode_array_type_for_record_array = psycopg2.extensions.new_array_type(
+        RECORD_ARRAY,
+        "ARRAY_RECORD",
+        unicode_type_for_record
+    )
+
+    # This registers a unicode type caster for datatype 'RECORD'.
+    psycopg2.extensions.register_type(unicode_type_for_record)
+
+    # This registers a array unicode type caster for datatype 'ARRAY_RECORD'.
+    psycopg2.extensions.register_type(unicode_array_type_for_record_array)
+
+    # define type caster to convert various pg types into string type
+    pg_types_to_string_type = psycopg2.extensions.new_type(
+        TO_STRING_DATATYPES + TO_STRING_NUMERIC_DATATYPES +
+        PSYCOPG_SUPPORTED_RANGE_TYPES, 'TYPECAST_TO_STRING', _STRING
+    )
+
+    # define type caster to convert pg array types of above types into
+    # array of string type
+    pg_array_types_to_array_of_string_type = \
+        psycopg2.extensions.new_array_type(
+            TO_ARRAY_OF_STRING_DATATYPES,
+            'TYPECAST_TO_ARRAY_OF_STRING', pg_types_to_string_type
+        )
+
+    # This registers a type caster to convert various pg types into string type
+    psycopg2.extensions.register_type(pg_types_to_string_type)
+
+    # This registers a type caster to convert various pg array types into
+    # array of string type
+    psycopg2.extensions.register_type(pg_array_types_to_array_of_string_type)
+
+    # Treat JSON data as text because converting it to dict alters the data
+    # which should not happen as per postgres docs
+    psycopg2.extras.register_default_json(loads=lambda x: x)
+    psycopg2.extras.register_default_jsonb(loads=lambda x: x)
+
+    # pysycopg2 adapt does not support dict by default. Need to register
+    # Used http://initd.org/psycopg/docs/extras.html#json-adaptation
+    psycopg2.extensions.register_adapter(dict, psycopg2_json)
+
+
+def register_string_typecasters(connection):
+    # raw_unicode_escape used for SQL ASCII will escape the
+    # characters. Here we unescape them using unicode_escape
+    # and send ahead. When insert update is done, the characters
+    # are escaped again and sent to the DB.
+
+    postgres_encoding, python_encoding, typecast_encoding = \
+        get_encoding(connection.encoding)
+    if postgres_encoding != 'UNICODE':
+        def non_ascii_escape(value, cursor):
+            if value is None:
+                return None
+            return bytes(
+                value, encodings[cursor.connection.encoding]
+            ).decode(typecast_encoding, errors='replace')
+
+        unicode_type = psycopg2.extensions.new_type(
+            # "char", name, text, character, character varying
+            (19, 18, 25, 1042, 1043, 0),
+            'UNICODE', non_ascii_escape)
+
+        unicode_array_type = psycopg2.extensions.new_array_type(
+            # "char"[], name[], text[], character[], character varying[]
+            (1002, 1003, 1009, 1014, 1015, 0
+             ), 'UNICODEARRAY', unicode_type)
+
+        psycopg2.extensions.register_type(unicode_type, connection)
+        psycopg2.extensions.register_type(unicode_array_type, connection)
+
+
+def numeric_typecasters(results, conn_obj):
+    # This function is to convert pg types to numeic type caster
+
+    numeric_cols = []
+    for obj_type in conn_obj.column_info:
+        if obj_type['type_code'] in TO_STRING_NUMERIC_DATATYPES:
+            numeric_cols.append(obj_type['name'])
+
+    for result in results:
+        for key, value in result.items():
+            if isinstance(result[key],
+                          str) and key in numeric_cols and not value.isdigit():
+                result[key] = float(result[key])
+            elif isinstance(result[key], str) and key in numeric_cols:
+                result[key] = int(result[key])
+    return results
+
+
+def register_binary_typecasters(connection):
+    psycopg2.extensions.register_type(
+        psycopg2.extensions.new_type(
+            (
+                # To cast bytea type
+                17,
+            ),
+            'BYTEA_PLACEHOLDER',
+            # Only show placeholder if data actually exists.
+            lambda value, cursor: 'binary data'
+            if value is not None else None),
+        connection
+    )
+
+    psycopg2.extensions.register_type(
+        psycopg2.extensions.new_type(
+            (
+                # To cast bytea[] type
+                1001,
+            ),
+            'BYTEA_ARRAY_PLACEHOLDER',
+            # Only show placeholder if data actually exists.
+            lambda value, cursor: 'binary data[]'
+            if value is not None else None),
+        connection
+    )
+
+
+def register_array_to_string_typecasters(connection):
+    psycopg2.extensions.register_type(
+        psycopg2.extensions.new_type(
+            PSYCOPG_SUPPORTED_BUILTIN_ARRAY_DATATYPES +
+            PSYCOPG_SUPPORTED_JSON_ARRAY_TYPES +
+            PSYCOPG_SUPPORTED_IPADDRESS_ARRAY_TYPES +
+            PSYCOPG_SUPPORTED_RANGE_ARRAY_TYPES +
+            TO_ARRAY_OF_STRING_DATATYPES,
+            'ARRAY_TO_STRING',
+            _STRING),
+        connection
+    )
+
+
+def unregister_numeric_typecasters(connection):
+    string_type_to_decimal = \
+        psycopg2.extensions.new_type(TO_STRING_NUMERIC_DATATYPES,
+                                     'TYPECAST_TO_DECIMAL', _DECIMAL)
+    psycopg2.extensions.register_type(string_type_to_decimal, connection)
diff --git a/web/pgadmin/utils/driver/psycopg3/connection.py b/web/pgadmin/utils/driver/psycopg3/connection.py
index 016c01fa6..e39179c37 100644
--- a/web/pgadmin/utils/driver/psycopg3/connection.py
+++ b/web/pgadmin/utils/driver/psycopg3/connection.py
@@ -508,7 +508,7 @@ class Connection(BaseConnection):
         if self.use_binary_placeholder:
             register_binary_typecasters(self.conn)
         #
-        postgres_encoding, self.python_encoding, typecast_encoding = \
+        postgres_encoding, self.python_encoding = \
             get_encoding(self.conn.info.encoding)
 
         # Note that we use 'UPDATE pg_settings' for setting bytea_output as a
@@ -782,30 +782,6 @@ WHERE db.datname = current_database()""")
                 25,
                 'Failed to reset cursor in reset_cursor_at method')
 
-    def escape_params_sqlascii(self, params):
-        # The data is unescaped using string_typecasters when selected
-        # We need to esacpe the data so that it does not fail when
-        # it is encoded with python ascii
-        # unicode_escape helps in escaping and unescaping
-        if self.conn and \
-            self.conn.info.encoding in ('SQL_ASCII', 'SQLASCII',
-                                        'MULE_INTERNAL', 'MULEINTERNAL'
-                                        ) and params is not None\
-                and isinstance(params, dict):
-            for key, val in params.items():
-                modified_val = val
-                # "unicode_escape" will convert single backslash to double
-                # backslash, so we will have to replace/revert them again
-                # to store the correct value into the database.
-                if isinstance(val, str):
-                    modified_val = val.encode('unicode_escape')\
-                        .decode('raw_unicode_escape')\
-                        .replace("\\\\", "\\")
-
-                params[key] = modified_val
-
-        return params
-
     def __internal_blocking_execute(self, cur, query, params):
         """
         This function executes the query using cursor's execute function,
@@ -820,8 +796,6 @@ WHERE db.datname = current_database()""")
         """
 
         query = query.encode(self.python_encoding)
-
-        params = self.escape_params_sqlascii(params)
         cur.execute(query, params)
 
     def execute_on_server_as_csv(self, formatted_exception_msg=False,
@@ -1052,9 +1026,6 @@ WHERE db.datname = current_database()""")
             formatted exception message
         """
 
-        # Convert the params based on python_encoding
-        params = self.escape_params_sqlascii(params)
-
         self.__async_cursor = None
         status, cur = self.__cursor(scrollable=True)
 
@@ -1350,30 +1321,23 @@ WHERE db.datname = current_database()""")
                 "Asynchronous query execution/operation underway."
             )
 
-        if self.row_count > 0:
-            result = []
-            # For DDL operation, we may not have result.
-            #
-            # Because - there is not direct way to differentiate DML and
-            # DDL operations, we need to rely on exception to figure
-            # that out at the moment.
-            try:
-                if records == -1:
-                    res = cur.fetchall()
-                else:
-                    res = cur.fetchmany(records)
-                for row in res:
-                    new_row = []
-                    for col in self.column_info:
-                        new_row.append(row[col['name']])
-                    result.append(new_row)
-            except psycopg.ProgrammingError:
-                result = None
-        else:
-            # User performed operation which dose not produce record/s as
-            # result.
-            # for eg. DDL operations.
-            return True, None
+        more_results = True
+        while more_results:
+            if self.row_count > 0:
+                result = []
+                try:
+                    if records == -1:
+                        result = cur.fetchall(_tupples=True)
+                    else:
+                        result = cur.fetchmany(records, _tupples=True)
+                except psycopg.ProgrammingError:
+                    result = None
+            else:
+                # User performed operation which dose not produce record/s as
+                # result.
+                # for eg. DDL operations.
+                return True, None
+            more_results = cur.nextset()
 
         return True, result
 
@@ -1498,7 +1462,7 @@ Failed to reset the connection to the server due to following error:
     def poll(self, formatted_exception_msg=False, no_result=False):
         cur = self.__async_cursor
 
-        if self.conn.pgconn.is_busy():
+        if self.conn and self.conn.pgconn.is_busy():
             status = 3
         else:
             status = 1
@@ -1516,32 +1480,31 @@ Failed to reset the connection to the server due to following error:
                 query_id=self.__async_query_id
             )
         )
-        if not self.conn.pgconn.is_busy():
-            if cur.description is not None:
-                self.column_info = [
-                    desc.to_dict() for desc in cur.ordered_description()
-                ]
-
-                pos = 0
-                for col in self.column_info:
-                    col['pos'] = pos
-                    pos += 1
-
-            self.row_count = cur.get_rowcount()
-            if not no_result and cur.get_rowcount() > 0:
-                result = []
-                # For DDL operation, we may not have result.
-                #
-                # Because - there is not direct way to differentiate DML
-                # and DDL operations, we need to rely on exception to
-                # figure that out at the moment.
-                try:
-                    result = cur.fetchalltupple()
+        more_result = True
+        while more_result:
+            if not self.conn.pgconn.is_busy():
+                if cur.description is not None:
+                    for desc in cur.ordered_description():
+                        self.column_info = [
+                            desc.to_dict() for desc in cur.ordered_description()
+                        ]
 
-                except psycopg.ProgrammingError:
-                    result = None
-                except psycopg.Error:
-                    result = None
+                    pos = 0
+                    for col in self.column_info:
+                        col['pos'] = pos
+                        pos += 1
+
+                self.row_count = cur.get_rowcount()
+                if not no_result and cur.get_rowcount() > 0:
+                    result = []
+                    try:
+                        result = cur.fetchall(_tupples=True)
+
+                    except psycopg.ProgrammingError:
+                        result = None
+                    except psycopg.Error:
+                        result = None
+            more_result = cur.nextset()
 
         return status, result
 
diff --git a/web/pgadmin/utils/driver/psycopg3/cursor.py b/web/pgadmin/utils/driver/psycopg3/cursor.py
index c73774d9c..b0b021821 100644
--- a/web/pgadmin/utils/driver/psycopg3/cursor.py
+++ b/web/pgadmin/utils/driver/psycopg3/cursor.py
@@ -263,8 +263,9 @@ class AsyncDictCursor(_async_cursor):
         """
         Use this to fetch the description
         """
-        if self._odt_desc is None:
-            self._ordered_description()
+
+        # if self._odt_desc is None:
+        self._ordered_description()
         return self._odt_desc
 
     def execute(self, query, params=None):
@@ -277,7 +278,6 @@ class AsyncDictCursor(_async_cursor):
         """
         Execute function
         """
-        self._odt_desc = None
         if params is not None and len(params) == 0:
             params = None
 
@@ -290,11 +290,17 @@ class AsyncDictCursor(_async_cursor):
         self._odt_desc = None
         return _async_cursor.executemany(self, query, params)
 
-    def fetchmany(self, size=None):
+    def fetchmany(self, size=None, _tupples=False):
         """
         Fetch many tuples as ordered dictionary list.
         """
-        return asyncio.run(self._fetchmany(size))
+        self._odt_desc = None
+        if _tupples:
+            self.row_factory = tuple_row
+        res = asyncio.run(self._fetchmany(size))
+        if _tupples:
+            self.row_factory = dict_row
+        return res
 
     async def _fetchmany(self, size=None):
         """
@@ -308,25 +314,16 @@ class AsyncDictCursor(_async_cursor):
         """
         return await _async_cursor.fetchall(self)
 
-    def fetchall(self):
-        """
-        Fetch all tuples as ordered dictionary list.
-        """
-        return asyncio.run(self._fetchall())
-
-    async def _fetchalltupple(self):
-        """
-        Fetch all tuples as ordered dictionary list.
-        """
-        return await _async_cursor.fetchall(self)
-
-    def fetchalltupple(self):
+    def fetchall(self, _tupples=False):
         """
         Fetch all tuples as ordered dictionary list.
         """
-        self.row_factory = tuple_row
-        res = asyncio.run(self._fetchalltupple())
-        self.row_factory = dict_row
+        self._odt_desc = None
+        if _tupples:
+            self.row_factory = tuple_row
+        res = asyncio.run(self._fetchall())
+        if _tupples:
+            self.row_factory = dict_row
         return res
 
     async def _fetchone(self):
diff --git a/web/pgadmin/utils/driver/psycopg3/encoding.py b/web/pgadmin/utils/driver/psycopg3/encoding.py
index 9b9265e50..69ee92f93 100644
--- a/web/pgadmin/utils/driver/psycopg3/encoding.py
+++ b/web/pgadmin/utils/driver/psycopg3/encoding.py
@@ -12,10 +12,12 @@
 import psycopg
 
 encode_dict = {
-    'SQL_ASCII': ['SQL_ASCII', 'raw-unicode-escape', 'unicode-escape'],
+    'SQL_ASCII': ['SQL_ASCII', 'raw-unicode-escape'],
+    'SQLASCII': ['SQLASCII', 'raw-unicode-escape'],
     # EUC_TW Not availble in Python,
     # so psycopg3 do not support it, we are on our own
-    'EUC_TW': ['BIG5', 'big5', 'big5']
+    'EUC_TW': ['BIG5', 'big5'],
+    'EUCTW': ['BIG5', 'big5']
 }
 
 
@@ -23,12 +25,12 @@ def get_encoding(key):
     """
     :param key: Database Encoding
     :return:
-    [Postgres_encoding, Python_encoding, typecast_encoding] -
+    [Postgres_encoding, Python_encoding] -
     Postgres encoding, Python encoding, type cast encoding
     """
     #
     # Reference: https://www.postgresql.org/docs/11/multibyte.html
-
+    #
     if key == 'ascii':
         key = 'raw_unicode_escape'
     postgres_encoding = psycopg._encodings.py2pgenc(key).decode()
@@ -36,10 +38,10 @@ def get_encoding(key):
     python_encoding = psycopg._encodings._py_codecs.get(postgres_encoding,
                                                         'utf-8')
 
-    return encode_dict.get(postgres_encoding.upper(),
+    _dict = encode_dict.get(postgres_encoding.upper(),
                            [postgres_encoding,
-                            python_encoding,
                             python_encoding])
+    return _dict
 
 
 def configure_driver_encodings(encodings):
@@ -50,7 +52,7 @@ def configure_driver_encodings(encodings):
     # python encoding of pyscopg's internal encodings dict.
 
     for key, val in encode_dict.items():
-        postgres_encoding, python_encoding, typecast_encoding = val
+        postgres_encoding, python_encoding = val
         psycopg._encodings._py_codecs[key] = python_encoding
 
     encodings.update((k.encode(), v
diff --git a/web/pgadmin/utils/driver/psycopg3/typecast.py b/web/pgadmin/utils/driver/psycopg3/typecast.py
index 58fefdf19..499ca651f 100644
--- a/web/pgadmin/utils/driver/psycopg3/typecast.py
+++ b/web/pgadmin/utils/driver/psycopg3/typecast.py
@@ -165,27 +165,13 @@ def register_string_typecasters(connection):
     # and send ahead. When insert update is done, the characters
     # are escaped again and sent to the DB.
 
-    postgres_encoding, python_encoding, typecast_encoding = \
+    postgres_encoding, python_encoding = \
         get_encoding(connection.info.encoding)
     if postgres_encoding != 'UTF-8' and postgres_encoding != 'UTF8':
 
-        # class NonAsciiLoader(Loader):
-        #     def load(self, data):
-        #         if data is None:
-        #             return None
-        #         postgres_encoding, python_encoding, typecast_encoding = \
-        #             get_encoding(self.connection.info.encoding)
-        #         return data.decode(python_encoding, errors='replace')
-
         for typ in (19, 18, 25, 1042, 1043, 0):
             if connection:
                 connection.adapters.register_loader(typ, TextLoaderpgAdmin)
-        # for typ in (1002, 1003, 1009, 1014, 1015, 0):
-        #     if connection:
-        #         connection.adapters.register_loader(typ,
-        #                                             TextLoaderpgAdmin)
-        # connection.adapters.register_loader(bytes, NonAsciiLoader)
-
 
 def register_binary_typecasters(connection):
     # The new classes can be registered globally, on a connection, on a cursor
@@ -232,16 +218,24 @@ class pgAdminByteaLoader(Loader):
 
 class TextLoaderpgAdmin(TextLoader):
     def load(self, data):
-        if self._encoding:
+        postgres_encoding, python_encoding = \
+            get_encoding(self.connection.info.encoding)
+        if postgres_encoding != 'SQLASCII' and postgres_encoding != 'SQL_ASCII':
             if isinstance(data, memoryview):
                 return bytes(data).decode(self._encoding)
             else:
-                return data.decode(self._encoding, errors='replace')
+                return data.decode(self._encoding)
         else:
             # SQL_ASCII db
-            postgres_encoding, python_encoding, typecast_encoding = \
-                get_encoding(self.connection.info.encoding)
             try:
-                return data.decode(typecast_encoding)
+                if isinstance(data, memoryview):
+                    return bytes(data).decode(python_encoding)
+                return data.decode(python_encoding)
             except Exception:
-                return data.decode('UTF-8', errors='replace')
+                    if isinstance(data, memoryview):
+                        return bytes(data).decode('UTF-8')
+                    return data.decode('UTF-8')
+            else:
+                if isinstance(data, memoryview):
+                    return bytes(data).decode('ascii', errors='replace')
+                return data.decode('ascii', errors='replace')
diff --git a/web/pgadmin/utils/driver/registry.py b/web/pgadmin/utils/driver/registry.py
index 6cbcde6d9..6ceaa58e8 100644
--- a/web/pgadmin/utils/driver/registry.py
+++ b/web/pgadmin/utils/driver/registry.py
@@ -15,6 +15,9 @@ from pgadmin.utils.dynamic_registry import create_registry_metaclass
 @classmethod
 def load_modules(cls, app=None):
     submodules = []
+    from . import psycopg2 as module
+    submodules.append(module)
+
     from . import psycopg3 as module
     submodules.append(module)
 
diff --git a/web/pgadmin/utils/route.py b/web/pgadmin/utils/route.py
index 5510ed2d7..8ca0cc443 100644
--- a/web/pgadmin/utils/route.py
+++ b/web/pgadmin/utils/route.py
@@ -17,7 +17,7 @@ from pgadmin.utils import server_utils
 from .. import socketio
 
 import unittest
-
+import config
 
 class TestsGeneratorRegistry(ABCMeta):
     """
@@ -133,6 +133,9 @@ class BaseTestGenerator(unittest.TestCase, metaclass=TestsGeneratorRegistry):
             'data' in server_con and 'type' in server_con['data'] and \
                 server_con['data']['type'] in self.skip_on_database:
             self.skipTest('cannot run in: %s' % server_con['data']['type'])
+        if hasattr(self, 'mock_data') and 'function_name' in self.mock_data:
+            self.mock_data['function_name'] = self.mock_data['function_name'
+            ].replace('psycopg3', config.PG_DEFAULT_DRIVER)
 
     def setTestServer(self, server):
         self.server = server
diff --git a/web/regression/python_test_utils/test_utils.py b/web/regression/python_test_utils/test_utils.py
index 16cd72c09..ff9e3201a 100644
--- a/web/regression/python_test_utils/test_utils.py
+++ b/web/regression/python_test_utils/test_utils.py
@@ -40,7 +40,11 @@ from pgadmin.utils import set_binary_path
 
 from functools import wraps
 
-import psycopg
+# Remove this condition, once psycopg2 will be removed completely
+if config.PG_DEFAULT_DRIVER == 'psycopg3':
+    import psycopg
+else:
+    import psycopg2 as psycopg
 
 CURRENT_PATH = os.path.abspath(os.path.join(os.path.dirname(
     os.path.realpath(__file__)), "../"))
diff --git a/web/regression/re_sql/tests/test_resql.py b/web/regression/re_sql/tests/test_resql.py
index 056289960..c621e742c 100644
--- a/web/regression/re_sql/tests/test_resql.py
+++ b/web/regression/re_sql/tests/test_resql.py
@@ -13,6 +13,7 @@ import traceback
 from urllib.parse import urlencode
 from flask import url_for
 import regression
+import config
 from regression import parent_node_dict
 from pgadmin.utils.route import BaseTestGenerator
 from regression.python_test_utils import test_utils as utils
@@ -99,13 +100,15 @@ class ReverseEngineeredSQLTestCases(BaseTestGenerator):
 
         # Schema ID placeholder in JSON file which needs to be replaced
         # while running the test cases
+
         self.JSON_PLACEHOLDERS = {'schema_id': '<SCHEMA_ID>',
                                   'owner': '<OWNER>',
                                   'timestamptz_1': '<TIMESTAMPTZ_1>',
                                   'password': '<PASSWORD>',
                                   'pga_job_id': '<PGA_JOB_ID>',
                                   'timestamptz_2': '<TIMESTAMPTZ_2>',
-                                  'db_name': '<TEST_DB_NAME>'}
+                                  'db_name': '<TEST_DB_NAME>',
+                                  'db_driver': '<DB_DRIVER>'}
 
         resql_module_list = create_resql_module_list(
             BaseTestGenerator.re_sql_module_list,
